package com.community.huiju.controller;

import com.community.commom.constant.Constant;
import com.community.commom.mode.ResponseBean;
import com.community.commom.session.UserElement;
import com.community.huiju.service.FaceServiceI;
import io.swagger.annotations.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.context.config.annotation.RefreshScope;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpSession;

@RestController
@RefreshScope
@RequestMapping("/")
@Api(value = "人脸相关API", description = "人脸相关API")
public class FaceController {
    @Autowired
    private FaceServiceI faceServicel;

    @ApiOperation(value = "添加人脸图片", notes = "添加人脸图片")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "header",dataType = "String",name = "X-Auth-Token",value = "Token")
    })
    
    @RequestMapping(value = "/addFace",method = RequestMethod.POST)
    public Object getTaFace(HttpSession session,
                            @ApiParam(value = "file" ,required = true) MultipartFile uploadFile){
        ResponseBean responseBean = new ResponseBean();
        UserElement userElement = (UserElement) session.getAttribute(Constant.APP_USER_SESSION);
        Integer userId = userElement.getId();
        responseBean = faceServicel.addFace(userId ,uploadFile);
        return responseBean;
    }

    @ApiOperation(value = "修改人脸图片", notes = "修改人脸图片")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "header",dataType = "String",name = "X-Auth-Token",value = "Token")
    })
    @RequestMapping(value = "/upDateFace",method = RequestMethod.POST)
    public Object upDateTaFace(HttpSession session,
                               @ApiParam(value = "file" ,required = true) MultipartFile uploadFile
                               ){
        ResponseBean responseBean = new ResponseBean();
        UserElement userElement = (UserElement) session.getAttribute(Constant.APP_USER_SESSION);
        Integer userId = userElement.getId();
         responseBean = faceServicel.upDateFace(userId,uploadFile);
        return responseBean;
    }

    @ApiOperation(value = "获取当前已录入人脸信息", notes = "获取当前已录入人脸信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "header",dataType = "String",name = "X-Auth-Token",value = "Token")
    })
    @RequestMapping(value = "/getUserIdFace",method = RequestMethod.GET)
    public Object getTaFaceByUserId(HttpSession session){
        UserElement userElement = (UserElement) session.getAttribute(Constant.APP_USER_SESSION);
        Integer userId = userElement.getId();
        ResponseBean responseBean = faceServicel.getTaFaceByUserId(userId );
        return responseBean;
    }

}
